public class GasTank
{
    public static int[] array1 = { 14, 8, 12, 6 };
    public static int[] array2 = { 14, 1, 1, 12, 12, 12, 12, 12, 12, 12 };

    public static void main( String[] args ) {
        System.out.println( "Array : { 14, 8, 12, 6 }" );
        System.out.println( "  brute force: " + bruteForce( array1 ) );
        System.out.println( "  one pass   : " + zoomin( array1 ) );
        System.out.println( "Array : { 14, 1, 1, <seven 12s> }" );
        System.out.println( "  brute force: " + bruteForce( array2 ) );
        System.out.println( "  one pass   : " + zoomin( array2 ) );
    }

    public static int bruteForce( int[] gas ) {
        int tank;
        outer:
        for ( int i = 0; i < gas.length; i++ ) {
            tank = 0;
            for ( int j = i; j < i + gas.length; j++ ) {
                tank = tank + gas[j % gas.length] - 10;
                if ( tank < 0 )
                    continue outer;
            }
            return i;
        }
        return -1;     // can't happen!
    }

    public static int zoomin( int[] gas ) {
        int minReading = Integer.MAX_VALUE;
        int minStation = -1;
        int tank = 0;
        for ( int i = 0; i < gas.length; i++ ) {
            if ( tank < minReading ) {
                minReading = tank;
                minStation = i;
            }
            tank = tank + gas[i] - 10;
        }
        return minStation;
    }
}
